#ifndef BOCON_H
#define BOCON_H

#include <stdio.h>
#include "iotools.h"

class bocon
{
  public:
   bocon();
   ~bocon();

   /// reads data from the opened text file
   long read(XFILE *in, long ndof);

   /// return pointer to new allocated object with copy of the actual instance
   bocon *copy(void);

   /// merges boundary conditions of the instance with the one defined in object tbc
   bocon *merge(bocon *tbc);

   long    nn;    ///< node number
   long    ndir;  ///< number of directions
   long   *dir;   ///< array flags for each direction
   double *con;   ///< array with prescribed values
   char   **expr; ///< array with prescribed functions
};

#endif
