#ifndef OUTPUT_H
#define OUTPUT_H
#include <stdio.h>
#include "descrip.h"

/// main output function
long output(FILE *out, descrip *d);

/// output nodes
long wr_nodes(FILE *out);

/// output nodes for layered problems
long wr_lay_nodes(FILE *out);

/// output boundary conditions
long wr_bocon(FILE *out);

/// output elements
long wr_elements(FILE *out, descrip *d);

/// output elements for layered problems
long wr_lay_elements(FILE *out, descrip *d);

/// output global node numbers for paralell computing
long wr_globnodnum(FILE *out, descrip *d);

/// output integration point section (already not used)
long wr_intpoints(FILE *out, long nprop);

/// output materials
long wr_materials(FILE *out);

/// output auxiliary point section
long wr_auxpoint(FILE *out);

/// output section with local coordinate systems on the elements
long wr_ellcsys(FILE *out);

/// output cross-sections
long wr_crsecs(FILE *out);

/// load controling function
long wr_load(FILE *out);

/// output nodal load
long wr_loadn(FILE *out, long nlc);

/// output element load
long wr_loadel(FILE *out, long nlc);

/// output nodal dynamical load
long wr_dloadn(FILE *out, long nlc);

/// output element dynamical load
long wr_dloadel(FILE *out, long nlc);

/// output prescribed displacements
long wr_prescdisp(FILE *out, long nlc);

/// output of macro stress components for homogenization problems
long wr_macrostress(FILE *out, long nlc);

/// output dynamical prescribed displacements
long wr_dprescdisp(FILE *out, long nlc);

/// output temperature load
long wr_tempload(FILE *out, long nlc);

/// output initial conditions
long wr_initcond(FILE *out, long nlc);

/// output of element eigenstrains
long wr_eigenstrains(FILE *out);

long get_nspring();
#endif
