#ifndef MTGLVEC_H
#define MTGLVEC_H

struct mt_glob_vec
{
  /// step id
  long istep;


  // Following pointers are not allocated, 
  // they are used as references to arrays allocated somewhere else

  ///  vector of nodal displacements
  double *r;
  ///  vector of nodal prescribed forces
  double *f;
  
  // Following pointers to arrays are allocated 
  // allocation of vectors  

  ///  vector of increments of nodal displacements
  double *dr;
  ///  vector of prescribed forces from the previous step
  double *fp;
  ///  vector of prescribed force loads, it does not contain forces caused by temperature, etc.
  double *fl;
  ///  vector of internal forces
  double *fi;
  ///  auxiliary force vector
  double *fb;
  ///  backup of the nodal displacements
  double *lhsb;

  /// Default constructor 
  mt_glob_vec();
  /// function allocates vectors dr, fp, fl, fi, fb and lhsb
  void alloc(long n);
  /// function deallocates vectors dr, fp, fl, fi, fb and lhsb
  void dealloc();
  /// Destructor deallocates vectors dr, fp, fl, fi, fb and lhsb
  ~mt_glob_vec();
};

#endif
